#include <amxmodx>
#include <amxmisc>
#include <codmod>
#include <fun>
#include <engine>
#include <hamsandwich>

#define FALL_VELOCITY 350.0
#define DMG_BULLET (1<<1)
        
new const nazwa[]   = "Elitarny Alkaida";
new const opis[]    = "Ma 1/3 na natychmiastowe zabicie z he, nie traci obrazen od upadku.";
new const bronie    = (1<<CSW_HEGRENADE)|(1<<CSW_SMOKEGRENADE)|(1<<CSW_FLASHBANG)|(1<<CSW_AK47);
new const zdrowie   = 20;
new const kondycja  = 10;
new const inteligencja = 0;
new const wytrzymalosc = 0;

new bool:ma_klase[33];
new bool:falling[33];
    
public plugin_init()
{
	register_plugin(nazwa, "1.0", "hasztag");

	cod_register_advance(cod_get_classid("Wyszkolony Alkaida"), 80, nazwa, opis, bronie, zdrowie, kondycja, inteligencja, wytrzymalosc);
        
                  RegisterHam(Ham_TakeDamage, "player", "TakeDamage");
}

public cod_class_enabled(id)
{
	give_item(id, "weapon_hegrenade");
                  give_item(id, "weapon_flashbang");
	give_item(id, "weapon_flashbang");
	give_item(id, "weapon_smokegrenade");

                  ma_klase[id] = true;

}

public cod_class_disabled(id)
{
        ma_klase[id] = false;

}

public TakeDamage(this, idinflictor, idattacker, Float:damage,

damagebits)
{
if(!is_user_connected(idattacker))
return HAM_IGNORED;

if(!ma_klase[idattacker])
return HAM_IGNORED;

if(damagebits & DMG_BULLET)
{
new weapon = get_user_weapon(idattacker);

if(weapon == CSW_HEGRENADE && damage > 20.0 &&

random_num(1,3) == 1)
cod_inflict_damage(idattacker, this,

float(get_user_health(this))-damage+1.0, 0.0, idinflictor,

damagebits);

}

return HAM_IGNORED;
}

public client_PreThink(id) {
if(ma_klase[id] && is_user_alive(id) && is_user_connected(id))
{
if(entity_get_float(id, EV_FL_flFallVelocity) >= FALL_VELOCITY) {
falling[id] = true;
}
else
{
falling[id] = false;
}
}
}

public client_PostThink(id) {
if(ma_klase[id] && is_user_alive(id) && is_user_connected(id))
{
if(falling[id]) {
entity_set_int(id, EV_INT_watertype, -3);
}
}
}
