#include <amxmodx>
#include <codmod>
#include <hamsandwich>
#include <cstrike>
#include <fakemeta>

#define DMG_BULLET (1<<1)
#define ZADANIE_WSKRZES 6240

new const nazwa[] = "Hardkorowy Komandos";
new const opis[] = "Natychmiastowe zabicie z noza (PPM), wbudowany modul odrzutowy, ma nieskonczana amunicje, 1/4 szansy na odrodzenie sie po smierci.";
new const bronie = (1<<CSW_DEAGLE)|(1<<CSW_MAC10);
new const zdrowie = 40;
new const kondycja = 60;
new const inteligencja = 5;
new const wytrzymalosc = 10;

new ma_klase[33];

public plugin_init() {
	register_plugin(nazwa, "1.0", "hasztag");
	
                  cod_register_advance(cod_get_classid("Elitarny Komandos"), 120, nazwa, opis, bronie, zdrowie, kondycja, inteligencja, wytrzymalosc);

	RegisterHam(Ham_TakeDamage, "player", "fwTakeDamage_JedenCios");

                  register_event("CurWeapon","CurWeapon","be", "1=1");

                  RegisterHam(Ham_Killed, "player", "Killed", 1);

}
public cod_class_enabled(id)
{
	ma_klase[id] = true;

}

public cod_class_disabled(id)
{
	ma_klase[id] = false;

}
	
public cod_class_skill_used(id)
{
	static Float:ostatni_skok[33];
	new flags = pev(id, pev_flags);
	
	if(flags & FL_ONGROUND && get_gametime() > ostatni_skok[id]+4.0)
	{
		ostatni_skok[id] = get_gametime();
		new Float:velocity[3];
		velocity_by_aim(id, 666+cod_get_user_intelligence(id), velocity);
		velocity[2] = random_float(265.0,285.0);
		set_pev(id, pev_velocity, velocity);
	}
}
public fwTakeDamage_JedenCios(id, ent, attacker)
{
	if(is_user_alive(attacker) && ma_klase[attacker] && get_user_weapon(attacker) == CSW_KNIFE)
	{
		cs_set_user_armor(id, 0, CS_ARMOR_NONE);
		SetHamParamFloat(4, float(get_user_health(id) + 1));
		return HAM_HANDLED;
	}
	return HAM_IGNORED;
}

public CurWeapon(id)
{
	if(!is_user_connected(id))
		return;
	
	if(!ma_klase[id])
		return;
	
	set_user_clip(id, 2);
}
	

stock set_user_clip(id, ammo)
{
	new weaponname[32], weaponid = -1, weapon = get_user_weapon(id, _, _);
	get_weaponname(weapon, weaponname, 31);
	while ((weaponid = engfunc(EngFunc_FindEntityByString, weaponid, "classname", weaponname)) != 0)
		if (pev(weaponid, pev_owner) == id) {
		set_pdata_int(weaponid, 51, ammo, 4);
		return weaponid;
	}
	return 0;
}

public Killed(id)

{

    if(ma_klase[id] && random_num(1, 4) == 1)

        set_task(0.1, "Wskrzes", id+ZADANIE_WSKRZES);

}



public Wskrzes(id)

    ExecuteHamB(Ham_CS_RoundRespawn, id-ZADANIE_WSKRZES);
