#include <amxmodx>
#include <codmod>
#include <hamsandwich>
#include <engine>
#include <fun>
#include <cstrike>

#define DMG_BULLET (1<<1) 

new bool:ma_klase[33];

new const nazwa[] = "Hardkorowy Snajper";
new const opis[] = "170 % (+int) z awp, 1/2 na natychmiastowe zabicie z noza (PPM), obrazenia nie sa oslabiane przez wytrzymalosc wroga, mniejsza widocznosc, ma ubranie wroga.";
new const bronie = (1<<CSW_HEGRENADE)|(1<<CSW_SMOKEGRENADE)|(1<<CSW_ELITE)|(1<<CSW_AWP)|(1<<CSW_DEAGLE);
new const zdrowie = 20;
new const kondycja = 10;
new const inteligencja = 0;
new const wytrzymalosc = 0;

new CT_Skins[4][] = {"sas","gsg9","urban","gign"};
new Terro_Skins[4][] = {"arctic","leet","guerilla","terror"};

new Float:redukcja_obrazen_gracza[33];

public plugin_init() 
{
	register_plugin(nazwa, "1.0", "hasztag");
	
	cod_register_advance(cod_get_classid("Elitarny Snajper"), 120, nazwa, opis, bronie, zdrowie, kondycja, inteligencja, wytrzymalosc);
	RegisterHam(Ham_TakeDamage, "player", "TakeDamage");
        RegisterHam(Ham_TakeDamage, "player", "TakeDamage_wytrzymalosc");
}

public cod_class_enabled(id)
{

	set_rendering(id,kRenderFxNone, 0, 0, 0, kRenderTransAlpha, 50);
                  ZmienUbranie(id, 0);
                  give_item(id, "weapon_hegrenade");
	give_item(id, "weapon_smokegrenade");
	ma_klase[id] = true;

}

public cod_class_disabled(id)
{
	set_rendering(id,kRenderFxNone, 0, 0, 0, kRenderTransAlpha, 255);
                  ZmienUbranie(id, 1);
    	ma_klase[id] = false;

}

public TakeDamage(this, idinflictor, idattacker, Float:damage, damagebits)
{
	if(!is_user_connected(idattacker))
		return HAM_IGNORED; 
	
	if(!ma_klase[idattacker])
		return HAM_IGNORED;
	
	if(damagebits & DMG_BULLET)
	{
		new weapon = get_user_weapon(idattacker);
		
		if(weapon == CSW_KNIFE && damage > 20.0 && random_num(1,2) == 1) 
			cod_inflict_damage(idattacker, this, float(get_user_health(this))-damage+1.0, 0.0, idinflictor, damagebits);
			
		if(weapon == CSW_AWP)
			cod_inflict_damage(idattacker, this, damage*1.0, 0.7, idinflictor, damagebits);	
	}
	
	return HAM_IGNORED;
}

public TakeDamage_wytrzymalosc(this, idinflictor, idattacker, Float:damage, damagebits)
{
	if(!is_user_connected(idattacker))
		return HAM_IGNORED;

	if(!ma_klase[idattacker])
		return HAM_IGNORED;

	if(!cod_get_user_stamina(this))
		return HAM_IGNORED;

	redukcja_obrazen_gracza[this] = 0.7*(1.0-floatpower(1.1, -0.112311341*cod_get_user_stamina(this)));
	SetHamParamFloat(4, damage/(1.0-redukcja_obrazen_gracza[this]))

	return HAM_IGNORED;
}

public ZmienUbranie(id,reset)
{
    if (!is_user_connected(id))
        return PLUGIN_CONTINUE; 

    if (reset)
        cs_reset_user_model(id);
    else
    {
        new num = random_num(1,1);
        cs_set_user_model(id, (get_user_team(id) == 1)? CT_Skins[num]: Terro_Skins[num]);
    }
    return PLUGIN_CONTINUE;
}